import fiji.robot.*;

/* 
 * Oggetto per far attraversare labirinti (generici)
 * a un robot. 
 */
public class AttraversatoreLabirinti {

    /* Fa attraversare a robbie un generico labirinto. */
    public static void attraversaLabirinto(Robot robbie) {
        // pre: robbie si trova all'ingresso di un labirinto

        /* fai entrare robbie nel labirinto */
        robbie.avanza();
        /* finch robbie  dentro al labirinto,
         * fai avanzare robbie, facendogli avere sempre
         * un muro alla sua sinistra */
        while (robbie.dentro()) {
            /* metti robbie nella direzione in cui deve avanzare */
            /* prova a far andare robbie a sinistra */
            robbie.giraSinistra();
            if (robbie.fronteAlMuro()) {
                /* prova a far avanzare robbie */
                robbie.giraDestra();
                if (robbie.fronteAlMuro()) {
                    /* prova a far andare robbie a destra */
                    robbie.giraDestra();
                    if (robbie.fronteAlMuro()) {
                        /* fai andare robbie all'indietro */
                        robbie.giraDestra();
                    }
                }
            }
            /* fai avanzare robbie */
            robbie.avanza();
        }
    }

    /* Applicazione di prova. */
    public static void main(String[] args) {
        Labirinto l;   // labirinto semplice
        Robot r;       // robot nel labirinto l

        /* crea il labirinto (casuale) e il robot */
        l = new Labirinto();
        r = new Robot(l);
        /* fa attraversare il labirinto l a r */
        AttraversatoreLabirinti.attraversaLabirinto(r);
        /* ora r  all'uscita di l */
    }
}