/* 
 * Oggetto per calcolare la somma dei primi n numeri interi positivi. 
 */
public class SommatorePositivi {
	
    /* Calcola la somma dei primi n numeri interi positivi. */
    public static int sommaPrimiPositivi(int n) {
        // pre: n>=0
        int somma;    // somma dei primi n numeri positivi
        int i;        // per iterare tra 1 e n

        /* inizializza somma */
        somma = 0;

        /* per ogni valore di i compreso tra 1 e n,
         * incrementa somma di i */
        i = 1;
        while (i<=n) {  
            /* incrementa somma di i */
            somma = somma + i;
            /* incrementa i */
            i = i + 1;
        }
        
        /* il risultato  somma */
        return somma;
    }

    /* Calcola la somma dei primi n numeri interi positivi
     * usando la formula di Gauss. */
    public static int sommaPrimiPositiviGauss(int n) {
        // pre: n >= 0
        int somma;   // somma dei primi n numeri positivi

        /* calcola la somma dei primi n numeri positivi */
        somma = n*(n+1)/2;
        /* il risultato  somma */
        return somma;
    }

    /* metodo di test */
    public static void main(String[] args) {
        int sommaPrimiQuattro;    // somma dei primi quattro
                                  // numeri interi positivi

        /* calcola la somma dei primi quattro numeri positivi */
        System.out.print("Calcolo la somma dei primi 4 positivi " +
                         "mediante somma ripetute: ");
        sommaPrimiQuattro =
            SommatorePositivi.sommaPrimiPositivi(4);
        /* e la visualizza sullo schermo */
        System.out.println(sommaPrimiQuattro);

        /* calcola la somma dei primi quattro numeri positivi */
        System.out.print("Calcolo la somma dei primi 4 positivi " +
                         "mediante la formula di Gauss: ");
        sommaPrimiQuattro =
            SommatorePositivi.sommaPrimiPositiviGauss(4);
        /* e la visualizza sullo schermo */
        System.out.println(sommaPrimiQuattro);
    }
}