import java.util.Scanner;

/* 
 * Applicazione per giocare al gioco "Indovina che numero ho pensato". 
 * 
 * L'applicazione sceglie un numero intero casuale compreso 
 * tra 1 e 100 (estremi inclusi), e poi chiedere all'utente di 
 * indovinare il numero scelto. 
 * Dopo ogni tentativo, l'applicazione segnala se la risposta 
 *  giusta, oppure se il numero immesso dall'utente  maggiore 
 * (troppo alto!) oppure minore (troppo basso!) rispetto a quello 
 * scelto dall'applicazione. 
 * L'applicazione continua a chiedere numeri all'utente fino a che 
 * questi non abbia dato la risposta corretta o abbia scelto di 
 * rinunciare ad indovinare, digitando il numero zero.  
 * Inoltre, l'applicazione conta il numero di tentativi fatti 
 * dall'utente per indovinare il numero, e lo visualizza quando 
 * viene fornita la risposta corretta. 
 */ 
public class AltoBasso { 
    public static void main(String[] args) { 
        int numeroScelto;     // il numero che deve essere indovinato 
        int tentativo;        // il numero digitato dall'utente 
        int tentativiFatti;   // numero di tentativi fatti dall'utente 
        final int MAX = 100;  // numero massimo che pu essere scelto 
        final int FINE = 0;   // il numero che deve essere digitato 
                              // dall'utente per smettere
        Scanner in;       // per la lettura dalla tastiera 

        /* crea un oggetto per leggere dalla tastiera */ 
        in = new Scanner( System.in ); 

        /* sceglie un numero intero compreso tra 1 e MAX */ 
        numeroScelto = (int) (Math.random()*MAX+1); 
        
        /* stampa un messaggio */ 
        System.out.println(
            "Ho pensato un numero intero compreso tra 1 e " + MAX); 
        System.out.println("Indovina che numero ho pensato!"); 
        System.out.println("Ricorda che puoi digitare " + FINE + 
                           " se vuoi smettere di giocare"); 
        
        /* legge e elabora i tentativi fatti dall'utente, 
         * fino a quando il numero scelto non viene indovinato, 
         * oppure fino a quando l'utente non vuole smettere di giocare */ 
        System.out.print("Indovina che numero ho pensato: "); 
        tentativo = in.nextInt(); 
        /* conta il tentativo fatto */ 
        tentativiFatti = 1; 
        while (tentativo!=numeroScelto && tentativo!=FINE) { 
            /* l'utente non ha indovinato il numero */ 
            /* visualizza un messaggio che dice se  troppo alto 
             * oppure troppo basso */ 
            if (tentativo<numeroScelto) {
                System.out.println(tentativo + "  troppo basso."); 
            } else {
                System.out.println(tentativo + "  troppo alto.");
            }
            /* conteggia il tentativo */ 
            tentativiFatti++; 
            /* chiede il prossimo numero */ 
            System.out.print("Indovina che numero ho pensato: "); 
            tentativo = in.nextInt(); 
        } 
        /* il numero  stato indovinato oppure l'utente ha 
         * deciso di smettere */ 
        if (tentativo==numeroScelto) {    // il numero  stato indovinato
            System.out.print("Bravo! ");
            System.out.println("Hai indovinato facendo " + 
                               tentativiFatti + " tentativi!");
        } else {    // l'utente ha deciso di smettere
            System.out.println("Il numero che avevo scelto era " + 
                               numeroScelto + ".");
            System.out.println(" stato un piacere giocare con te!");
        } 
    } 
    
} 