/* 
 * Verifica se un numero  perfetto o difettivo. 
 */ 
public class NumeriInteri { 
	
    /* Verifica se il numero n  perfetto. */
    public static boolean perfetto(int n) {
        // pre: n>0
        /* n  perfetto se  uguale alla somma
         * dei suoi divisori interi */
        return n==sommaDivisori(n);
    }

    /* Verifica se il numero n  difettivo. */
    public static boolean difettivo(int n) {
        // pre: n>0
        /* n  difettivo se la somma dei suoi divisori interi
         *  minore di n */
        return sommaDivisori(n)<n;
    }

    /* Calcola la somma dei divisori interi di n, n escluso. */
    private static int sommaDivisori(int n) {
        // pre: n>0
        int sd;    // somma dei divisori interi di n
        int d;     // per iterare da 1 a n-1

        /* calcola la somma dei divisori di n */
        sd = 0;
        for (d=1; d<n; d++) {
            if (n%d==0) {
                sd += d;
            }
        }
        return sd;
    }
    
    /* Applicazione di prova. */ 
    public static void main(String[] args) { 
        /* la somma dei divisori di 6  6 */ 
        System.out.println(sommaDivisori(6) + ": (6)");    

        /* la somma dei divisori di 10  8 */ 
        System.out.println(sommaDivisori(10) + ": (8)");    
        
        /* 6  perfetto */ 
        System.out.println(perfetto(6) + ": (true)");    
        /* anche 28  perfetto */ 
        System.out.println(perfetto(28) + ": (true)");    
        /* 10 non  perfetto */ 
        System.out.println(perfetto(10) + ": (false)");    

        /* 10  difettivo */ 
        System.out.println(difettivo(10) + ": (true)");    
        /* 6 non  difettivo */ 
        System.out.println(difettivo(6) + ": (false)");    
    } 
} 