/* 
 * Ricerca binaria in un array ordinato. 
 */ 
public class RicercaBinaria { 

    /* Ricerca chiave nell'array a ordinato in modo
     * non descrescente, restituendo la posizione di un elemento
     * di a uguale a chiave, oppure -1. */
    public static int ricercaBinaria(int[] a, int chiave) {
        // pre: a!=null && a  ordinato in modo non decrescente
        int posizione;    // posizione di un elemento di a
                          // uguale a chiave, se esiste
        int sinistra;     // indice del primo elemento dello
                          // spazio di ricerca
        int destra;       // indice del primo elemento oltre
                          // lo spazio di ricerca
        int centro;       // indice dell'elemento centrale dello
                          // spazio di ricerca

        /* inizialmente lo spazio di ricerca comprende
         * tutti gli elementi di a */
        sinistra = 0;
        destra = a.length;
        /* cerca la posizione di un elemento di a uguale
         * a chiave, se esiste, mediante la ricerca binaria */
        posizione = -1;
        while (sinistra<destra) {
            centro = (sinistra+destra)/2;
            if (a[centro]==chiave) {      // trovato
                posizione = centro;
                break; 
            } else if (a[centro]>chiave) {  // continua a sinistra
                destra = centro;
            } else {                        // continua a destra
                sinistra = centro+1;
            }
        }
        return posizione;
    } 
    
} 