import static org.junit.Assert.*;

import org.junit.Test;


public class TestRicercaSequenziale {

    @Test 
    public void testRicerca_Vuoto_NonTrovato() {
        assertEquals(-1, RicercaSequenziale.ricercaSequenziale( new int[] { }, 5 ));
    }
    
    @Test 
    public void testRicerca_UnElemento_Trovato() {
        assertEquals(0, RicercaSequenziale.ricercaSequenziale( new int[] { 5 }, 5 ));
    }

    @Test 
    public void testRicerca_UnElemento_NonTrovato() {
        assertEquals(-1, RicercaSequenziale.ricercaSequenziale( new int[] { 5 }, 2 ));
    }
    
    @Test 
    public void testRicerca_PiElementi_Trovato_Inizio() {
        assertEquals(0, RicercaSequenziale.ricercaSequenziale( new int[] { 5, 4, 12, 9, 0, 2, 16, 2 }, 5 ));
    }

    @Test 
    public void testRicerca_PiElementi_Trovato_Met() {
        assertEquals(3, RicercaSequenziale.ricercaSequenziale( new int[] { 5, 4, 12, 9, 0, 2, 16, 2 }, 9 ));
    }

    @Test 
    public void testRicerca_PiElementi_Trovato_Ripetuto() {
        assertEquals(5, RicercaSequenziale.ricercaSequenziale( new int[] { 5, 4, 12, 9, 0, 2, 16, 2 }, 2 ));
    }

    @Test 
    public void testRicerca_PiElementi_NonTrovato() {
        assertEquals(-1, RicercaSequenziale.ricercaSequenziale( new int[] { 5, 4, 12, 9, 0, 2, 16, 2 }, 11 ));
    }

}
