/* 
 * Uguaglianza tra array di array. 
 */ 
public class Uguali { 

    /* Verifica se gli array di array a e b sono uguali. */
    public static boolean uguali(int[][] a, int[][] b) {
        // pre: a!=null && b!=null &&
        //      gli elementi di a e b sono non nulli
        int i;             // indice per la scansione di a e b
        boolean uguali;    // a e b sono uguali

        /* verifica se a e b sono uguali */
        if (a.length!=b.length) {   // sono sicuramente diversi
            uguali = false;
        } else {
            /* a e b sono uguali se lo sono riga per riga */
            uguali = true;
            for (i=0; i<a.length; i++) {
                if (!uguali(a[i], b[i])) {
                    uguali = false;
                    break; 
                }
            }
        }
        return uguali;
    }

    /* Verifica se gli array a e b sono tra loro uguali. */
    public static boolean uguali(int[] a, int[] b) {
        // pre: a!=null && b!=null
        int i;             // indice per la scansione di a e b
        boolean uguali;    // a e b sono uguali

        /* verifica se a e b sono uguali */
        if (a.length!=b.length) {   /* a e b sono diversi */
            uguali = false;
        } else {
            /* a e b sono uguali
             * se lo sono elemento per elemento */
            uguali = true;
            for (i=0; i<a.length; i++) {
                if (a[i]!=b[i]) {
                    uguali = false;
                    break; 
                }
            }
        }
        return uguali;
    }

    /* Applicazione di prova. */ 
    public static void main(String[] args) { 
        /* array di array vuoti */
        System.out.println(uguali(new int[][] { }, 
                                  new int[][] { }) + " (true)");
        /* array di array uguali */
        System.out.println(uguali(new int[][] { {1, 5} , {7, 9} }, 
                                  new int[][] { {1, 5} , {7, 9} }) + " (true)");
        /* array di array diversi */
        System.out.println(uguali(new int[][] { {1, 3} , {7, 9} }, 
                                  new int[][] { {1, 5} , {7, 9} }) + " (false)");
        /* array di array diversi */
        System.out.println(uguali(new int[][] { {1, 3} , {7, 9} }, 
                                  new int[][] { {1, 3} , {7, 9, 1} }) + " (false)");
    } 
} 