/* 
 * Un oggetto CorpoCeleste rappresenta un corpo celeste. 
 */ 
public class CorpoCeleste { 
    /* Il nome del corpo celeste. */
    private String nome;
    /* Il centro di rotazione del corpo celeste, ovvero
     * il corpo celeste intorno a cui avviene la rotazione. */
    private CorpoCeleste centroRotazione;

    /* Crea un nuovo CorpoCeleste, dato nome e centro. */ 
    public CorpoCeleste(String nome, CorpoCeleste cr) { 
        this.nome = nome; 
        this.centroRotazione = cr; 
    } 

    /* Crea un nuovo CorpoCeleste, che non ruota intorno 
     * a nessun altro corpo celeste. */ 
    public CorpoCeleste(String nome) { 
        /* invoca l'altro costruttore */ 
        this(nome, null); 
    } 

    /* Calcola la descrizione testuale di questo corpo celeste. */
    public String toString() {
        String descrizione;    // descrizione del corpo celeste

        descrizione = nome;
        if (this.centroRotazione!=null) {   // caso induttivo
            descrizione += " (ruota intorno a " +
                           this.centroRotazione.toString() + ")";
        }
        return descrizione;
    }

    /* Applicazione di prova. */ 
    public static void main(String[] args) { 
        CorpoCeleste sun, earth, mars, moon; 
        /* il sole non ruota intorno ad altri corpi celesti */ 
        sun = new CorpoCeleste("sole"); 
        /* la terra e marte ruotano intorno al sole */ 
        earth = new CorpoCeleste("terra", sun); 
        mars = new CorpoCeleste("marte", sun); 
        /* la luna ruota intorno alla terra */ 
        moon = new CorpoCeleste("luna", earth); 
        
        System.out.println(sun.toString()); 
        System.out.println(earth.toString()); 
        System.out.println(moon.toString()); 
        System.out.println(mars.toString()); 
    } 
} 