/* 
 * Ricerca binaria ricorsiva in un array ordinato. 
 */ 
public class RicercaBinaria { 

    /* Ricerca chiave nell'array a ordinato in modo
     * non descrescente, e restituisce la posizione di un
     * elemento di a uguale a chiave (oppure -1). */
    public static int ricercaBinaria(int[] a, int chiave) {
        // pre: a!=null && a  ordinato in modo non decrescente
        /* cerca chiave tra tutti gli elementi di a */
        return ricBinRic(a, chiave, 0, a.length);
    }

    /* Verifica se a contiene un elemento uguale a chiave con
     * posizione tra sinistra (compreso) e destra (escluso). */
    private static int ricBinRic(int[] a, int chiave,
                                 int sinistra, int destra) {
        int posizione;    // posizione di un elemento di a
                          // uguale a chiave, se esiste
        int centro;       // indice dell'elemento centrale dello
                          // spazio di ricerca

        /* cerca la posizione di un elemento di a,
         * tra sinistra e destra, uguale a chiave */
        centro = (sinistra+destra)/2;
        if (sinistra>=destra) {     // la ricerca  fallita
            posizione = -1;
        } else if (a[centro]==chiave) {   // trovato!
            posizione = centro;
        } else if (a[centro]>chiave) {    // continua a sinistra
            posizione = ricBinRic(a, chiave, sinistra, centro);
        } else {                          // continua a destra
            posizione = ricBinRic(a, chiave, centro+1, destra);
        }
        return posizione;
    }

} 