/* 
 * Ordinamento a bolle. 
 */ 
public class BubbleSort { 

    /* Ordina l'array dati in modo non decrescente.
     * Ordinamento a bolle. */
    public static void bubbleSort(int[] dati) {
        // pre: dati!=null
        int n;           // lunghezza di dati
        int i;           // indice per la scansione di dati
        int ordinati;    // numero di elementi ordinati
        int ultimoScambio;    // posizione in cui  avvenuto
                              // l'ultimo scambio durante la
                              // passata corrente
        /* ultimoScambio vale 0 se non sono stati ancora
         * eseguiti scambi durante la passata corrente */

        /* ordina dati in modo non decrescente
         * (ordinamento a bolle) */
        n = dati.length;
        ordinati = 0;
        /* esegue passate finch dati non  ordinato */
        while (ordinati<n-1) {
            /* gli elementi ordinati sono quelli di indice
             * tra n-ordinati (compreso) e n (escluso) */
            /* confronta ogni elemento non ordinato
             * con quello che lo precede */
            ultimoScambio = 0;
            for (i=1; i<n-ordinati; i++) {
                if (dati[i]<dati[i-1]) {
                    scambia(dati, i, i-1);
                    ultimoScambio = i;
                }
            }
            /* ora gli elementi ordinati sono quelli di indice
             * tra ultimoScambio (compreso) e n (escluso) */
            ordinati = n-ultimoScambio;
        }
    }

    /* Scambia gli elementi di indice i e j di dati. */
    private static void scambia(int[] dati, int i, int j) {
        // pre: dati!=null && 0<= i,j <dati.length
        int temp;    // variabile di supporto per lo scambio

        /* scambia dati[i] con dati[j] */
        temp = dati[i];
        dati[i] = dati[j];
        dati[j] = temp;
    }

} 