/* 
 * Bubble sort bidirezionale. 
 */ 
public class BubbleSortBidirezionale { 

    /* Ordina l'array dati in modo non decrescente. 
     * Ordinamento a bolle bidirezionale. */
    public static void bubbleSortBidirezionale(int[] dati) {
        // pre: dati!=null 
        int n;     // lunghezza di dati 
        int i;     // indice per la scansione di dati 
        int os;    // numero di elementi ordinati a sinistra
        int od;    // numero di elementi ordinati a destra 
        int ultimoScambio;    // posizione in cui  avvenuto 
                              // l'ultimo scambio durante la 
                              // passata corrente 
        /* ultimoScambio vale 0 se non sono stati ancora 
         * eseguiti scambi durante la passata corrente */ 
        boolean direzione;    // direzione della passata 
        /* direzione vale true se la passata corrente va 
         * da sinistra verso destra */ 

        /* ordina dati in modo non decrescente 
         * (ordinamento a bolle bidirezionale) */ 
        n = dati.length; 
        os = 0; 
        od = 0; 
        direzione = true;    // prima passata verso destra 
        /* esegue passate finch dati non  ordinato */ 
        while ((os+od)<n) { 
            /* effettua una passata */ 
            if (direzione) {     // da sinistra verso destra 
                ultimoScambio = os;  
                for (i=os+1; i<n-od; i++) {
                    if (dati[i]<dati[i-1]) {
                        scambia(dati, i, i-1);
                        ultimoScambio = i;
                    }
                }
                od = n-ultimoScambio;
            } else {             // da destra verso sinistra 
                ultimoScambio = n-od;  
                for (i=n-1-od; i>os; i--) { 
                    if (dati[i]<dati[i-1]) {
                        scambia(dati, i, i-1);
                        ultimoScambio = i;
                    }
                }
                os = ultimoScambio;
            }
            direzione = !direzione; 
        } 
    } 
    
    /* Scambia gli elementi di indice i e j di dati. */
    private static void scambia(int[] dati, int i, int j) {
        // pre: dati!=null && 0<= i,j <dati.length
        int temp;    // variabile di supporto per lo scambio

        /* scambia dati[i] con dati[j] */
        temp = dati[i];
        dati[i] = dati[j];
        dati[j] = temp;
    }

} 