import static org.junit.Assert.*;

import java.util.Arrays;
import java.util.Collection;

import org.junit.Before;
import org.junit.Test;

import org.junit.runner.RunWith;
import org.junit.runners.Parameterized;
import org.junit.runners.Parameterized.Parameters;

/*
 * Non  un vero e proprio test, 
 * ma sfrutta JUnit per misurare il tempo di esecuzione. 
 */
@RunWith(value = Parameterized.class)
public class PrestazioniAlgoritmiOrdinamento {

	public static final boolean TEST_SELECTION = true; 
	public static final boolean TEST_INSERTION = true; 
	public static final boolean TEST_MERGE = true; 
	public static final boolean TEST_QUICK = true; 
	public static final boolean TEST_QUICK_JAVA = true; 
	public static final boolean TEST_BUBBLE_SEMPLICE = true; 
	public static final boolean TEST_BUBBLE = true; 
	public static final boolean TEST_BUBBLE_BIDIR = true; 
	
	private int length;  /* dimensione dell'array da ordinare */ 
	private int repetitions;  /* numero di array da ordinare */ 
	private int seed;  
	private RandomArrayGenerator rag;
	/* ordina molti array, non uno solo */ 
	private int[][] array; 
	
	public PrestazioniAlgoritmiOrdinamento(int length, int repeat, int seed) {
		this.length = length; 
		this.repetitions = repeat; 
		this.seed = seed; 
	}
	
	@Parameters
	public static Collection<Object[]> data() {
		return Arrays.asList( 
				new Object[][] { 
						{ 10000, 10, 314 },
//						{ 1000, 1, 628 },
					}
				);
	}

    @Before
	public  void setUp() {
    	this.rag = new RandomArrayGenerator(seed);
    	this.array = new int[repetitions][];
    	for (int i=0; i<repetitions; i++) {
    		this.array[i] = rag.getRandomArray(length);
    	}
	}

	@Test
	public void testGenerazioneArray() {
		assertTrue(true);
	}

	@Test
	public void testSelectionSort() {
		if (!TEST_SELECTION) {
			return; 
		}
    	for (int i=0; i<repetitions; i++) {
    		SelectionSort.selectionSort(array[i]);
    	}
		assertTrue(true);
	}

	@Test
	public void testSimpleBubbleSort() {
		if (!TEST_BUBBLE_SEMPLICE) {
			return; 
		}
    	for (int i=0; i<repetitions; i++) {
    		SimpleBubbleSort.simpleBubbleSort(array[i]);
    	}
		assertTrue(true);
	}

	@Test
	public void testBubbleSort() {
		if (!TEST_BUBBLE) {
			return; 
		}
    	for (int i=0; i<repetitions; i++) {
    		BubbleSort.bubbleSort(array[i]);
    	}
		assertTrue(true);
	}

	@Test
	public void testBidirBubbleSort() {
		if (!TEST_BUBBLE_BIDIR) {
			return; 
		}
    	for (int i=0; i<repetitions; i++) {
    		BubbleSortBidirezionale.bubbleSortBidirezionale(array[i]);
    	}
		assertTrue(true);
	}

	@Test
	public void testInsertionSort() {
		if (!TEST_INSERTION) {
			return; 
		}
    	for (int i=0; i<repetitions; i++) {
    		InsertionSort.insertionSort(array[i]);
    	}
		assertTrue(true);
	}

	@Test
	public void testMergeSort() {
		if (!TEST_MERGE) {
			return; 
		}
    	for (int i=0; i<repetitions; i++) {
    		MergeSort.mergeSort(array[i]);
    	}
		assertTrue(true);
	}

	@Test
	public void testQuickSort() {
		if (!TEST_QUICK) {
			return; 
		}
    	for (int i=0; i<repetitions; i++) {
    		QuickSort.quickSort(array[i]);
    	}
		assertTrue(true);
	}

	@Test
	public void testQuickSortJava() {
		if (!TEST_QUICK_JAVA) {
			return; 
		}
    	for (int i=0; i<repetitions; i++) {
    		Arrays.sort(array[i]);
    	}
		assertTrue(true);
	}

}
