/* 
 * Ordinamento veloce. 
 */ 
public class QuickSort { 

    /* Ordina l'array dati in modo non decrescente. 
     * Ordinamento per selezione. */ 
    public static void quickSort(int[] dati) { 
        int n = dati.length;   // lunghezza di dati 
            
        /* ordina tutti gli elementi di dati */ 
        quickSortRic(dati, 0, n-1); 
            // 0 e n-1 delimitano la porzione 
            // di array da ordinare (cio tutto) 
    }

    private static void quickSortRic(int[] dati, 
            int sinistra, int destra) { 
        int n;         // elementi da ordinare 
        int centro;    // per una ulteriore suddivisione 
        n = destra-sinistra+1; 
        if (n>1) {  // caso ricorsivo 
            centro = partition(dati, sinistra, destra); 
            quickSortRic(dati, sinistra, centro-1);  
            quickSortRic(dati, centro+1, destra);  
        } 
    } 

    private static int partition(int[]dati, int sinistra, int destra) { 
        boolean finito = false; 
        int risultato = 0; 
        while (!finito) { 
            while (sinistra<destra && dati[sinistra]<dati[destra]) {
                destra--; 
            }
            if (sinistra<destra) { 
                scambia(dati, sinistra++, destra); 
            } else { 
                risultato = sinistra; 
                finito = true; 
            } 
            while (sinistra<destra && dati[sinistra]< dati[destra]) { 
                sinistra++; 
            }
            if (sinistra<destra) { 
                scambia(dati, sinistra, destra--); 
            } else { 
                risultato = destra; 
                finito = true;
            } 
        }
        return risultato; 
    } 
    
    /* Scambia gli elementi di indice i e j di dati. */
    private static void scambia(int[] dati, int i, int j) {
        // pre: dati!=null && 0<= i,j <dati.length
        int temp;    // variabile di supporto per lo scambio

        /* scambia dati[i] con dati[j] */
        temp = dati[i];
        dati[i] = dati[j];
        dati[j] = temp;
    }

} 