import java.util.Random;

/*
 * Classe di utilit per la generazione di array casuali, 
 * da usare nel calcolo delle prestazioni dei diversi metodi 
 * di ordinamento. 
 */
public class RandomArrayGenerator {

	/* seme di default per la generazione di numeri casuali */ 
	public final static int DEFAULT_RANDOM_SEED = 2512;

	/* generatore di numeri casuali */ 
    private Random random;  

	public RandomArrayGenerator(int seed) {
		this.random = new Random(seed);
	}
	
	public RandomArrayGenerator() {
		this.random = new Random(DEFAULT_RANDOM_SEED);
	}

	/* Crea un array di n numeri casuali, dato il seme seed. */ 
    public int[] getRandomArray(int n) { 
        // pre: n>=0 
        int[] a;    // array di numeri casuali
        int i;      // indice per la scansione di a 
        
        /* crea l'array a */ 
        a = new int[n]; 
        /* assegna valori casuali agli elementi di a */ 
        for (i=0; i<n; i++) {
            /* numeri causali compresi tra 0 e 100*n-1 */ 
            a[i] = random.nextInt(100*n);
        }
        return a; 
    } 
    
}
