/* 
 * Ordinamento per selezione. 
 */ 
public class SelectionSort { 

    /* Ordina l'array dati in modo non decrescente.
     * Ordinamento per selezione. */
    public static void selectionSort(int[] dati) {
        // pre: dati!=null
        int n;           // lunghezza di dati
        int i;           // indice per la scansione di dati
        int ordinati;    // numero di elementi ordinati
        int imin;        // indice dell'elemento di valore minimo
                         // tra gli elementi non ordinati

        /* ordina dati in modo non decrescente
         * (ordinamento per selezione) */
        n = dati.length;
        /* esegue n-1 passate */
        for (ordinati=0; ordinati<n-1; ordinati++) {
            /* gli elementi ordinati sono quelli di indice
             * tra 0 (compreso) e ordinati (escluso) */
            /* cerca il minimo tra i non ordinati */
            imin = ordinati;
            for (i=ordinati+1; i<n; i++) {
                if (dati[i]<dati[imin]) {
                    imin = i;
                }
            }
            /* ordina l'elemento in imin */
            scambia(dati, ordinati, imin);
            /* ora gli elementi ordinati sono quelli di
             * indice compreso tra 0 e ordinati (incluso) */
        }
    }

    /* Scambia gli elementi di indice i e j di dati. */
    private static void scambia(int[] dati, int i, int j) {
        // pre: dati!=null && 0<= i,j <dati.length
        int temp;    // variabile di supporto per lo scambio

        /* scambia dati[i] con dati[j] */
        temp = dati[i];
        dati[i] = dati[j];
        dati[j] = temp;
    }

} 