/* 
 * Ordinamento a bolle elementare. 
 */ 
public class SimpleBubbleSort { 

    /* Ordina l'array dati in modo non decrescente.
     * Ordinamento a bolle -- versione elementare. */
    public static void simpleBubbleSort(int[] dati) {
        // pre: dati!=null
        int n;           // lunghezza di dati
        int i;           // indice per la scansione di dati
        int ordinati;    // numero di elementi ordinati

        /* ordina dati in modo non decrescente
         * (ordinamento a bolle -- versione elementare) */
        n = dati.length;
        /* esegue n-1 passate */
        for (ordinati=0; ordinati<n-1; ordinati++) {
            /* gli elementi ordinati sono quelli di indice
             * tra n-ordinati (compreso) e n (escluso) */
            /* confronta ogni elemento non ordinato con quello
             * che lo precede (ed eventualmente li scambia) */
            for (i=1; i<n-ordinati; i++) {
                if (dati[i]<dati[i-1]) {
                    scambia(dati, i, i-1);
                }
            }
            /* ora gli elementi ordinati sono quelli di indice
             * tra n-ordinati-1 (compreso) e n (escluso) */
        }
    }
    
    /* Scambia gli elementi di indice i e j di dati. */
    private static void scambia(int[] dati, int i, int j) {
        // pre: dati!=null && 0<= i,j <dati.length
        int temp;    // variabile di supporto per lo scambio

        /* scambia dati[i] con dati[j] */
        temp = dati[i];
        dati[i] = dati[j];
        dati[j] = temp;
    }
 
} 