import javax.swing.*;
import java.awt.GridLayout; 
import java.awt.event.*; 

/* 
 * L'applicazione ConvertitoreTemperature 
 * consente di effettuare conversioni da gradi Celsius a gradi Fahrenheit.
 * F = 32 + 1.8C 
 * */
public class ConvertitoreTemperature extends JFrame {
    /* variabili d'istanza per i componenti dell'interfaccia */ 
    /* campo di testo per l'immissione della temperatura */
    private JTextField campoTemperatura;
    /* etichetta per visualizzare la temperatura convertita */
    private JLabel etichettaTemperaturaConvertita;
    /* pulsante per chiedere la conversione a gradi Celsius */
    JButton pulsanteACelsius;
    /* pulsante per chiedere la conversione a gradi Fahrenheit */
    JButton pulsanteAFahrenheit;
    
    /* altre variabili d'istanza */
    
    /* Crea una nuova applicazione PremiIlBottone. */
    public ConvertitoreTemperature() {
        /* inizializza la frame */
        super();

        /* inizializzazioni locali */ 

        /* l'esecuzione dell'applicazione termina con
         * la chiusura della frame */
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        /* assegna un titolo alla frame */
        this.setTitle("Convertitore Celsius/Fahrenheit");

        /* inizializza l'interfaccia dell'applicazione */
        this.inizializzaGUI();

        /* dimensiona e visualizza la frame */
        this.pack();
        this.setVisible(true);
    }
    
    /* Inizializza l'interfaccia grafica dell'applicazione
     * e la gestione degli eventi. */
    private void inizializzaGUI() {
        /* pannello usato come contenitore intermedio */
        JPanel intermedio;
        /* pannello per i pulsanti */ 
        JPanel pannelloPulsanti; 

        /* ascoltatore per gli eventi d'azione */
        ActionListener asc;
        
        /* crea il contenitore intermedio */
        intermedio = new JPanel();
     
        /* crea il gestore di layout del contenitore intermedio */
        intermedio.setLayout( new GridLayout(1,3) );
        
        /* crea il contenitore per i pulsanti */
        pannelloPulsanti = new JPanel();
     
        /* crea il gestore di layout del pannello per i pulsanti */
        pannelloPulsanti.setLayout( new GridLayout(2,1) );

        /* crea i componenti dell'interfaccia grafica */ 
        /* crea il campo di testo per l'immissione della temperatura */
        campoTemperatura = new JTextField(6);
        campoTemperatura.setText("0.0"); 
        campoTemperatura.setHorizontalAlignment(JTextField.RIGHT); 
        /* crea l'etichetta per visualizzare la temperatura convertita */
        etichettaTemperaturaConvertita = new JLabel();
        etichettaTemperaturaConvertita.setText("0.0C = 32.0F");
        etichettaTemperaturaConvertita.setHorizontalAlignment(JTextField.RIGHT); 
        /* crea il pulsante per chiedere la conversione a gradi Celsius */
        pulsanteACelsius = new JButton("Converti a gradi Celsius");
        /* crea il pulsante per chiedere la conversione a gradi Fahrenheit */
        pulsanteAFahrenheit = new JButton("Converti a gradi Fahrenheit");
       
        /* crea gli ascoltatori di eventi */
        /* crea un ascoltatore degli eventi di azione */
        asc = new AscoltatorePerConvertitoreTemperature(this);
       
        /* registra le sorgenti di eventi */
        /* registra gli eventi del pulsante pulsanteACelsius */
        pulsanteACelsius.addActionListener(asc);
        /* registra gli eventi del pulsante pulsanteAFahrenheit */
        pulsanteAFahrenheit.addActionListener(asc);

        /* aggiunge i componenti al contenitore intermedio */
        /* aggiunge il campo di testo al pannello intermedio */
        intermedio.add(campoTemperatura);
        /* aggiunge i pulsanti al pannello dei pulsanti */
        pannelloPulsanti.add(pulsanteACelsius);
        pannelloPulsanti.add(pulsanteAFahrenheit);
        /* aggiunge il pannello dei pulsanti al pannello intermedio */
        intermedio.add(pannelloPulsanti);
        /* aggiunge il campo di testo al pannello intermedio */
        intermedio.add(etichettaTemperaturaConvertita);
       
        /* aggiunge il contenitore intermedio alla frame */
        this.getContentPane().add(intermedio);
    }
    
    /* altri metodi */

    /* Effettua una conversione a gradi Celsius. */
    public void aCelsius() {
        double f;    // temperatura in gradi Fahrenheit
        double c;    // temperatura in gradi Celsius

        /* legge la temperatura in gradi Fahrenheit */ 
        f = new Double(campoTemperatura.getText()).doubleValue(); 
        /* converte la temperatura in gradi Celsius */ 
        c = (f-32)/1.8; 
        /* visualizza la temperatura in gradi Celsius */ 
        etichettaTemperaturaConvertita.setText(f + "F = " + 
                                               c + "C");
    }

    /* Effettua una conversione a gradi Fahrenheit. */
    public void aFahrenheit() {
        double c;    // temperatura in gradi Celsius
        double f;    // temperatura in gradi Fahrenheit

        /* legge la temperatura in gradi Celsius */ 
        c = new Double(campoTemperatura.getText()).doubleValue(); 
        /* converte la temperatura in gradi Fahrenheit */ 
        f = c*1.8 + 32; 
        /* visualizza la temperatura in gradi Fahrenheit */ 
        etichettaTemperaturaConvertita.setText(c + "C = " + 
                                               f + "F");
    }

    /* L'applicazione ConvertitoreTemperature. */
    public static void main(String[] args) {
        /* crea ed avvia una nuova applicazione ConvertitoreTemperature */
        new ConvertitoreTemperature();
    }
}
