import javax.swing.*; 
import java.awt.GridLayout; 

/* 
 * Interfaccia che esemplifica l'uso del gestore di layout GridLayout. 
 */ 
public class DemoGridLayout extends JFrame { 
    private JButton pulsante1, pulsante2, pulsante3, 
                    pulsante4, pulsante5, pulsante6;    // vari pulsanti 
         
    /* Crea un nuovo DemoGridLayout. */ 
    public DemoGridLayout() { 
        /* inizializza la frame */ 
        super(); 

        /* l'esecuzione dell'applicazione termina con 
         * la chiusura della frame */ 
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE); 

        /* assegna un titolo alla frame */ 
        this.setTitle("Demo di GridLayout (3x2)"); 

        /* inizializza l'interfaccia dell'applicazione */ 
        this.inizializzaGUI(); 

        /* dimensiona e visualizza la frame */ 
        this.pack(); 
        this.setVisible(true);
    } 

    /* Inizializza l'interfaccia grafica dell'applicazione,
     * usando una griglia 3x2. */
    private void inizializzaGUI() {
        /* pannello usato come contenitore intermedio */
        JPanel intermedio;

        /* crea il contenitore intermedio */
        intermedio = new JPanel();
        /* crea il gestore di layout del contenitore intermedio */
        intermedio.setLayout( new GridLayout(3,2) );
        /* crea i componenti dell'interfaccia grafica */
        pulsante1 = new JButton("Uno");
        pulsante2 = new JButton("Due");
        pulsante3 = new JButton("Tre");
        pulsante4 = new JButton("Quattro");
        pulsante5 = new JButton("Cinque");
        pulsante6 = new JButton("Sei");
        /* aggiunge i componenti al contenitore intermedio */
        intermedio.add(pulsante1);
        intermedio.add(pulsante2);
        intermedio.add(pulsante3);
        intermedio.add(pulsante4);
        intermedio.add(pulsante5);
        intermedio.add(pulsante6);
        /* aggiunge il contenitore intermedio alla frame */
        this.getContentPane().add(intermedio);
    }

    /* L'applicazione DemoGridLayout. */ 
    public static void main(String[] args) { 
        /* crea ed avvia una nuova applicazione DemoGridLayout */ 
        new DemoGridLayout(); 
    }
} 