import javax.swing.*;

/* 
 * Una semplice interfaccia grafica, con un pulsante e un'etichetta. 
 */
public class UnaSempliceInterfacciaGrafica extends JFrame {
    private JLabel jLabel;    // una etichetta
    private JButton jButton;    // un bottone

    /* Crea una semplice interfaccia grafica. */
    public UnaSempliceInterfacciaGrafica() {
        /* inizializza la frame */
        super();

        /* l'esecuzione dell'applicazione termina con
         * la chiusura della frame */
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        /* assegna un titolo alla frame */
        this.setTitle("Una semplice interfaccia grafica");

        /* inizializza l'interfaccia dell'applicazione */
        this.inizializzaGUI();

        /* dimensiona e visualizza la frame */
        this.pack();
        this.setVisible(true);
    }

    /* Inizializza l'interfaccia dell'applicazione. */
    private void inizializzaGUI() {
        /* pannello, usato come contenitore intermedio */
        JPanel jPanel;

        /* crea il pannello */
        jPanel = new JPanel();

        /* crea i componenti dell'interfaccia */
        jLabel = new JLabel("Questa  un'etichetta");
        jButton = new JButton("Premi il pulsante!");

        /* aggiunge i componenti al pannello */
        jPanel.add(jLabel);
        jPanel.add(jButton);

        /* aggiunge il pannello alla frame */
        this.getContentPane().add(jPanel);
    }

    /* L'applicazione. */
    public static void main(String[] args) {
        /* crea ed avvia l'applicazione */
        new UnaSempliceInterfacciaGrafica();
    }
}